import fastJsonPatch from 'fast-json-patch';
import { createApplyLiveQueryPatch, noDiffSymbol, createApplyLiveQueryPatchGenerator, createLiveQueryPatchGenerator } from '@n1ru4l/graphql-live-query-patch';

const applyJSONPatch = (previous, patch) => {
    const result = fastJsonPatch.applyPatch(previous, patch, true, false);
    return result.newDocument;
};

const applyLiveQueryJSONPatch = createApplyLiveQueryPatch(applyJSONPatch);

const generateJSONPatch = (...args) => {
    const result = fastJsonPatch.compare(...args);
    if (result.length > 0) {
        return result;
    }
    return noDiffSymbol;
};

const applyLiveQueryJSONPatchGenerator = createApplyLiveQueryPatchGenerator(generateJSONPatch);

const liveQueryJSONPatchGenerator = createLiveQueryPatchGenerator(generateJSONPatch);

export { applyJSONPatch, applyLiveQueryJSONPatch, applyLiveQueryJSONPatchGenerator, generateJSONPatch, liveQueryJSONPatchGenerator };
