'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

const fastJsonPatch = _interopDefault(require('fast-json-patch'));
const graphqlLiveQueryPatch = require('@n1ru4l/graphql-live-query-patch');

const applyJSONPatch = (previous, patch) => {
    const result = fastJsonPatch.applyPatch(previous, patch, true, false);
    return result.newDocument;
};

const applyLiveQueryJSONPatch = graphqlLiveQueryPatch.createApplyLiveQueryPatch(applyJSONPatch);

const generateJSONPatch = (...args) => {
    const result = fastJsonPatch.compare(...args);
    if (result.length > 0) {
        return result;
    }
    return graphqlLiveQueryPatch.noDiffSymbol;
};

const applyLiveQueryJSONPatchGenerator = graphqlLiveQueryPatch.createApplyLiveQueryPatchGenerator(generateJSONPatch);

const liveQueryJSONPatchGenerator = graphqlLiveQueryPatch.createLiveQueryPatchGenerator(generateJSONPatch);

exports.applyJSONPatch = applyJSONPatch;
exports.applyLiveQueryJSONPatch = applyLiveQueryJSONPatch;
exports.applyLiveQueryJSONPatchGenerator = applyLiveQueryJSONPatchGenerator;
exports.generateJSONPatch = generateJSONPatch;
exports.liveQueryJSONPatchGenerator = liveQueryJSONPatchGenerator;
